Index: ntoskrnl/include/internal/ntoskrnl.h
===================================================================
--- ntoskrnl/include/internal/ntoskrnl.h	(revision 21808)
+++ ntoskrnl/include/internal/ntoskrnl.h	(working copy)
@@ -14,6 +14,7 @@
 #include "ke.h"
 #include "i386/mm.h"
 #include "i386/fpu.h"
+#include "i386/v86m.h"
 #include "ob.h"
 #include "mm.h"
 #include "ps.h"
@@ -51,7 +52,7 @@
 /*
  * Initalization functions (called once by main())
  */
-VOID MmInitSystem(ULONG Phase, PLOADER_PARAMETER_BLOCK LoaderBlock, ULONG LastKernelAddress);
+VOID MmInitSystem(ULONG Phase, PROS_LOADER_PARAMETER_BLOCK LoaderBlock, ULONG LastKernelAddress);
 VOID IoInit(VOID);
 VOID IoInit2(BOOLEAN BootLog);
 VOID STDCALL IoInit3(VOID);
@@ -63,7 +64,7 @@
 VOID CmShutdownRegistry(VOID);
 BOOLEAN CmImportSystemHive(PCHAR ChunkBase, ULONG ChunkSize);
 BOOLEAN CmImportHardwareHive(PCHAR ChunkBase, ULONG ChunkSize);
-VOID KdInitSystem(ULONG Reserved, PLOADER_PARAMETER_BLOCK LoaderBlock);
+VOID KdInitSystem(ULONG Reserved, PROS_LOADER_PARAMETER_BLOCK LoaderBlock);
 
 /* FIXME - RtlpCreateUnicodeString is obsolete and should be removed ASAP! */
 BOOLEAN FASTCALL
Index: ntoskrnl/include/internal/ex.h
===================================================================
--- ntoskrnl/include/internal/ex.h	(revision 21808)
+++ ntoskrnl/include/internal/ex.h	(working copy)
@@ -8,10 +8,10 @@
 extern ULONG ExpTimeZoneId;
 extern POBJECT_TYPE ExEventPairObjectType;
 
-#define EX_OBJ_TO_HDR(eob) ((POBJECT_HEADER)((ULONG_PTR)(eob) &                \
+#define EX_OBJ_TO_HDR(eob) ((PROS_OBJECT_HEADER)((ULONG_PTR)(eob) &                \
   ~(EX_HANDLE_ENTRY_PROTECTFROMCLOSE | EX_HANDLE_ENTRY_INHERITABLE |           \
   EX_HANDLE_ENTRY_AUDITONCLOSE)))
-#define EX_HTE_TO_HDR(hte) ((POBJECT_HEADER)((ULONG_PTR)((hte)->u1.Object) &   \
+#define EX_HTE_TO_HDR(hte) ((PROS_OBJECT_HEADER)((ULONG_PTR)((hte)->Object) &   \
   ~(EX_HANDLE_ENTRY_PROTECTFROMCLOSE | EX_HANDLE_ENTRY_INHERITABLE |           \
   EX_HANDLE_ENTRY_AUDITONCLOSE)))
 
Index: ntoskrnl/include/internal/lpc.h
===================================================================
--- ntoskrnl/include/internal/lpc.h	(revision 21808)
+++ ntoskrnl/include/internal/lpc.h	(working copy)
@@ -93,8 +93,11 @@
 VOID 
 STDCALL
 LpcpClosePort(
-    PVOID ObjectBody,
-    ULONG HandleCount
+    IN PEPROCESS Process OPTIONAL,
+    IN PVOID Object,
+    IN ACCESS_MASK GrantedAccess,
+    IN ULONG ProcessHandleCount,
+    IN ULONG SystemHandleCount
 );
 
 VOID
Index: ntoskrnl/include/internal/po.h
===================================================================
--- ntoskrnl/include/internal/po.h	(revision 21808)
+++ ntoskrnl/include/internal/po.h	(working copy)
@@ -6,7 +6,7 @@
 VOID
 NTAPI
 PoInit(
-    PLOADER_PARAMETER_BLOCK LoaderBlock, 
+    PROS_LOADER_PARAMETER_BLOCK LoaderBlock, 
     BOOLEAN ForceAcpiDisable
 );
 
Index: ntoskrnl/include/internal/ps.h
===================================================================
--- ntoskrnl/include/internal/ps.h	(revision 21808)
+++ ntoskrnl/include/internal/ps.h	(working copy)
@@ -8,6 +8,203 @@
 
 #include <internal/arch/ps.h>
 
+//
+// ROS Process
+//
+typedef struct _ROS_EPROCESS
+{
+    KPROCESS Pcb;
+    EX_PUSH_LOCK ProcessLock;
+    LARGE_INTEGER CreateTime;
+    LARGE_INTEGER ExitTime;
+    EX_RUNDOWN_REF RundownProtect;
+    HANDLE UniqueProcessId;
+    LIST_ENTRY ActiveProcessLinks;
+    ULONG QuotaUsage[3];
+    ULONG QuotaPeak[3];
+    ULONG CommitCharge;
+    ULONG PeakVirtualSize;
+    ULONG VirtualSize;
+    LIST_ENTRY SessionProcessLinks;
+    PVOID DebugPort;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    union
+    {
+        PVOID ExceptionPortData;
+        ULONG ExceptionPortValue;
+        UCHAR ExceptionPortState:3;
+    };
+#else
+    PVOID ExceptionPort;
+#endif
+    PHANDLE_TABLE ObjectTable;
+    EX_FAST_REF Token;
+    ULONG WorkingSetPage;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    EX_PUSH_LOCK AddressCreationLock;
+    PETHREAD RotateInProgress;
+#else
+    KGUARDED_MUTEX AddressCreationLock;
+    KSPIN_LOCK HyperSpaceLock;
+#endif
+    PETHREAD ForkInProgress;
+    ULONG HardwareTrigger;
+    MM_AVL_TABLE PhysicalVadroot;
+    PVOID CloneRoot;
+    ULONG NumberOfPrivatePages;
+    ULONG NumberOfLockedPages;
+    PVOID *Win32Process;
+    struct _EJOB *Job;
+    PVOID SectionObject;
+    PVOID SectionBaseAddress;
+    PEPROCESS_QUOTA_BLOCK QuotaBlock;
+    PPAGEFAULT_HISTORY WorkingSetWatch;
+    PVOID Win32WindowStation;
+    HANDLE InheritedFromUniqueProcessId;
+    PVOID LdtInformation;
+    PVOID VadFreeHint;
+    PVOID VdmObjects;
+    PVOID DeviceMap;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    ULONG AlpcPagedPoolQuotaCache;
+    PVOID EtwDataSource;
+    PVOID FreeTebHint;
+#else
+    PVOID Spare0[3];
+#endif
+    union
+    {
+        HARDWARE_PTE_X86 PagedirectoryPte;
+        ULONGLONG Filler;
+    };
+    ULONG Session;
+    CHAR ImageFileName[16];
+    LIST_ENTRY JobLinks;
+    PVOID LockedPagesList;
+    LIST_ENTRY ThreadListHead;
+    PVOID SecurityPort;
+    PVOID PaeTop;
+    ULONG ActiveThreads;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    ULONG ImagePathHash;
+#else
+    ACCESS_MASK GrantedAccess;
+#endif
+    ULONG DefaultHardErrorProcessing;
+    NTSTATUS LastThreadExitStatus;
+    struct _PEB* Peb;
+    EX_FAST_REF PrefetchTrace;
+    LARGE_INTEGER ReadOperationCount;
+    LARGE_INTEGER WriteOperationCount;
+    LARGE_INTEGER OtherOperationCount;
+    LARGE_INTEGER ReadTransferCount;
+    LARGE_INTEGER WriteTransferCount;
+    LARGE_INTEGER OtherTransferCount;
+    ULONG CommitChargeLimit;
+    ULONG CommitChargePeak;
+    PVOID AweInfo;
+    SE_AUDIT_PROCESS_CREATION_INFO SeAuditProcessCreationInfo;
+    MMSUPPORT Vm;
+    LIST_ENTRY MmProcessLinks;
+    ULONG ModifiedPageCount;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    union
+    {
+        struct
+        {
+            ULONG JobNotReallyActive:1;
+            ULONG AccountingFolded:1;
+            ULONG NewProcessReported:1;
+            ULONG ExitProcessReported:1;
+            ULONG ReportCommitChanges:1;
+            ULONG LastReportMemory:1;
+            ULONG ReportPhysicalPageChanges:1;
+            ULONG HandleTableRundown:1;
+            ULONG NeedsHandleRundown:1;
+            ULONG RefTraceEnabled:1;
+            ULONG NumaAware:1;
+            ULONG ProtectedProcess:1;
+            ULONG DefaultPagePriority:3;
+            ULONG ProcessDeleteSelf:1;
+            ULONG ProcessVerifierTarget:1;
+        };
+        ULONG Flags2;
+    };
+#else
+    ULONG JobStatus;
+#endif
+    union
+    {
+        struct
+        {
+            ULONG CreateReported:1;
+            ULONG NoDebugInherit:1;
+            ULONG ProcessExiting:1;
+            ULONG ProcessDelete:1;
+            ULONG Wow64SplitPages:1;
+            ULONG VmDeleted:1;
+            ULONG OutswapEnabled:1;
+            ULONG Outswapped:1;
+            ULONG ForkFailed:1;
+            ULONG Wow64VaSpace4Gb:1;
+            ULONG AddressSpaceInitialized:2;
+            ULONG SetTimerResolution:1;
+            ULONG BreakOnTermination:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+            ULONG DeprioritizeViews:1;
+#else
+            ULONG SessionCreationUnderway:1;
+#endif
+            ULONG WriteWatch:1;
+            ULONG ProcessInSession:1;
+            ULONG OverrideAddressSpace:1;
+            ULONG HasAddressSpace:1;
+            ULONG LaunchPrefetched:1;
+            ULONG InjectInpageErrors:1;
+            ULONG VmTopDown:1;
+            ULONG ImageNotifyDone:1;
+            ULONG PdeUpdateNeeded:1;
+            ULONG VdmAllowed:1;
+            ULONG SmapAllowed:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+            ULONG ProcessInserted:1;
+#else
+            ULONG CreateFailed:1;
+#endif
+            ULONG DefaultIoPriority:3;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+            ULONG SparePsFlags1:2;
+#else
+            ULONG Spare1:1;
+            ULONG Spare2:1;
+#endif
+        };
+        ULONG Flags;
+    };
+    NTSTATUS ExitStatus;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    USHORT Spare7;
+#else
+    USHORT NextPageColor;
+#endif
+    union
+    {
+        struct
+        {
+            UCHAR SubSystemMinorVersion;
+            UCHAR SubSystemMajorVersion;
+        };
+        USHORT SubSystemVersion;
+    };
+    UCHAR PriorityClass;
+    MM_AVL_TABLE VadRoot;
+    ULONG Cookie;
+    KEVENT LockEvent;
+    ULONG LockCount;
+    struct _KTHREAD *LockOwner;
+    MADDRESS_SPACE AddressSpace;
+} ROS_EPROCESS, *PROS_EPROCESS;
+
 extern LCID PsDefaultThreadLocaleId;
 extern LCID PsDefaultSystemLocaleId;
 extern LIST_ENTRY PspReaperListHead;
@@ -368,12 +565,12 @@
 NTSTATUS 
 NTAPI
 PsLockProcess(
-    PEPROCESS Process,
+    PROS_EPROCESS Process,
     BOOLEAN Timeout
 );
 
 VOID
 NTAPI
-PsUnlockProcess(PEPROCESS Process);
+PsUnlockProcess(PROS_EPROCESS Process);
 
 #endif /* __INCLUDE_INTERNAL_PS_H */
Index: ntoskrnl/ntoskrnl.rbuild
===================================================================
--- ntoskrnl/ntoskrnl.rbuild	(revision 21808)
+++ ntoskrnl/ntoskrnl.rbuild	(working copy)
@@ -45,7 +45,6 @@
 				<file>vdm.c</file>
 			</directory>
 		</if>
-		<compilationunit name="ke.c">
 			<file>apc.c</file>
 			<file>bug.c</file>
 			<file>clock.c</file>
@@ -68,26 +67,21 @@
 			<file>timer.c</file>
 			<file>usercall.c</file>
 			<file>wait.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="cc">
-		<compilationunit name="cc.c">
 			<file>cacheman.c</file>
 			<file>copy.c</file>
 			<file>fs.c</file>
 			<file>mdl.c</file>
 			<file>pin.c</file>
 			<file>view.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="cm">
-		<compilationunit name="cm.c">
 			<file>import.c</file>
 			<file>ntfunc.c</file>
 			<file>regfile.c</file>
 			<file>registry.c</file>
 			<file>regobj.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="kdbg">
 		<if property="ARCH" value="i386">
@@ -125,7 +119,6 @@
 				<file>fastinterlck_asm.S</file>
 			</directory>
 		</if>
-		<compilationunit name="ex.c">
 			<file>atom.c</file>
 			<file>callback.c</file>
 			<file>dbgctrl.c</file>
@@ -150,11 +143,9 @@
 			<file>win32k.c</file>
 			<file>work.c</file>
 			<file>zone.c</file>
-		</compilationunit>
 		<file>zw.S</file>
 	</directory>
 	<directory name="fs">
-		<compilationunit name="fs.c">
 			<file>context.c</file>
 			<file>fastio.c</file>
 			<file>filelock.c</file>
@@ -166,13 +157,11 @@
 			<file>tunnel.c</file>
 			<file>unc.c</file>
 			<file>util.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="inbv">
 		<file>inbv.c</file>
 	</directory>
 	<directory name="io">
-		<compilationunit name="io.c">
 			<file>adapter.c</file>
 			<file>arcname.c</file>
 			<file>bootlog.c</file>
@@ -205,11 +194,9 @@
 			<file>timer.c</file>
 			<file>vpb.c</file>
 			<file>wmi.c</file>
-		</compilationunit>
 		<file>file.c</file>
 	</directory>
 	<directory name="kd">
-		<compilationunit name="kd.c">
 			<directory name="wrappers">
 				<file>bochs.c</file>
 				<file>gdbstub.c</file>
@@ -217,16 +204,12 @@
 			<file>kdinit.c</file>
 			<file>kdio.c</file>
 			<file>kdmain.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="ldr">
-		<compilationunit name="ldr.c">
 			<file>loader.c</file>
 			<file>rtl.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="lpc">
-		<compilationunit name="lpc.c">
 			<file>close.c</file>
 			<file>complete.c</file>
 			<file>connect.c</file>
@@ -238,7 +221,6 @@
 			<file>receive.c</file>
 			<file>reply.c</file>
 			<file>send.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="mm">
 		<if property="ARCH" value="i386">
@@ -248,7 +230,6 @@
 				<file>pfault.c</file>
 			</directory>
 		</if>
-		<compilationunit name="mm.c">
 			<file>anonmem.c</file>
 			<file>aspace.c</file>
 			<file>balance.c</file>
@@ -280,12 +261,10 @@
 			<file>verifier.c</file>
 			<file>virtual.c</file>
 			<file>wset.c</file>
-		</compilationunit>
 		<file>elf32.c</file>
 		<file>elf64.c</file>
 	</directory>
 	<directory name="ob">
-		<compilationunit name="ob.c">
 			<file>dirobj.c</file>
 			<file>handle.c</file>
 			<file>namespc.c</file>
@@ -295,13 +274,11 @@
 			<file>security.c</file>
 			<file>symlink.c</file>
 			<file>wait.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="po">
 		<file>power.c</file>
 	</directory>
 	<directory name="ps">
-		<compilationunit name="ps.c">
 			<file>debug.c</file>
 			<file>idle.c</file>
 			<file>job.c</file>
@@ -316,7 +293,6 @@
 			<file>suspend.c</file>
 			<file>thread.c</file>
 			<file>win32.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="rtl">
 		<if property="ARCH" value="i386">
@@ -325,16 +301,13 @@
 				<file>seh.s</file>
 			</directory>
 		</if>
-		<compilationunit name="rtl.c">
 			<file>libsupp.c</file>
 			<file>misc.c</file>
 			<file>nls.c</file>
 			<file>regio.c</file>
 			<file>strtok.c</file>
-		</compilationunit>
 	</directory>
 	<directory name="se">
-		<compilationunit name="se.c">
 			<file>access.c</file>
 			<file>acl.c</file>
 			<file>audit.c</file>
@@ -345,7 +318,6 @@
 			<file>semgr.c</file>
 			<file>sid.c</file>
 			<file>token.c</file>
-		</compilationunit>
 	</directory>
 	<file>ntoskrnl.rc</file>
 	<linkerflag>-nostartfiles</linkerflag>
Index: ntoskrnl/inbv/inbv.c
===================================================================
--- ntoskrnl/inbv/inbv.c	(revision 21808)
+++ ntoskrnl/inbv/inbv.c	(working copy)
@@ -19,6 +19,13 @@
 #pragma alloc_text(INIT, InbvEnableBootDriver)
 #endif
 
+/* ROS Internal. Please deprecate */
+NTHALAPI
+VOID
+NTAPI
+HalReleaseDisplayOwnership(
+    VOID
+);
 
 /* GLOBALS *******************************************************************/
 
Index: ntoskrnl/kd/kdinit.c
===================================================================
--- ntoskrnl/kd/kdinit.c	(revision 21808)
+++ ntoskrnl/kd/kdinit.c	(working copy)
@@ -44,7 +44,7 @@
 PCHAR
 STDCALL
 KdpGetWrapperDebugMode(PCHAR Currentp2,
-                       PLOADER_PARAMETER_BLOCK LoaderBlock)
+                       PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 {
     PCHAR p2 = Currentp2;
 
@@ -160,7 +160,7 @@
 VOID
 INIT_FUNCTION
 KdInitSystem(ULONG BootPhase,
-             PLOADER_PARAMETER_BLOCK LoaderBlock)
+             PROS_LOADER_PARAMETER_BLOCK LoaderBlock)
 {
     ULONG Value;
     ULONG i;
Index: ntoskrnl/cm/cm.h
===================================================================
--- ntoskrnl/cm/cm.h	(revision 21808)
+++ ntoskrnl/cm/cm.h	(working copy)
@@ -459,6 +459,7 @@
 
 NTSTATUS STDCALL
 CmiObjectQueryName (PVOID ObjectBody,
+                    IN BOOLEAN HasObjectName,
 		    POBJECT_NAME_INFORMATION ObjectNameInfo,
 		    ULONG Length,
 		    PULONG ReturnLength);
Index: ntoskrnl/cm/registry.c
===================================================================
--- ntoskrnl/cm/registry.c	(revision 21808)
+++ ntoskrnl/cm/registry.c	(working copy)
@@ -369,7 +369,7 @@
   ObjectTypeInitializer.ValidAccessMask = KEY_ALL_ACCESS;
   ObjectTypeInitializer.UseDefaultObject = TRUE;
   ObjectTypeInitializer.DeleteProcedure = CmiObjectDelete;
-  ObjectTypeInitializer.ParseProcedure = CmiObjectParse;
+  ObjectTypeInitializer.ParseProcedure = (PVOID)CmiObjectParse;
   ObjectTypeInitializer.SecurityProcedure = CmiObjectSecurity;
   ObjectTypeInitializer.QueryNameProcedure = CmiObjectQueryName;
 
Index: ntoskrnl/cm/regobj.c
===================================================================
--- ntoskrnl/cm/regobj.c	(revision 21808)
+++ ntoskrnl/cm/regobj.c	(working copy)
@@ -486,6 +486,7 @@
 
 NTSTATUS STDCALL
 CmiObjectQueryName (PVOID ObjectBody,
+            IN BOOLEAN HasName,
 		    POBJECT_NAME_INFORMATION ObjectNameInfo,
 		    ULONG Length,
 		    PULONG ReturnLength)
Index: ntoskrnl/ke/device.c
===================================================================
--- ntoskrnl/ke/device.c	(revision 21808)
+++ ntoskrnl/ke/device.c	(working copy)
@@ -71,9 +71,9 @@
         else
         {
             /* Try to get a match */
-            if (Child->Component.Class == Class &&
-                Child->Component.Type == Type &&
-                (Child->Component.Key & Mask) == Key)
+            if (Child->ComponentEntry.Class == Class &&
+                Child->ComponentEntry.Type == Type &&
+                (Child->ComponentEntry.Key & Mask) == Key)
             {
                 /* Match found */
                 return Child;
@@ -93,9 +93,9 @@
             else
             {
                 /* Try to get a match */
-                if (Sibling->Component.Class == Class &&
-                    Sibling->Component.Type == Type &&
-                    (Sibling->Component.Key & Mask) == Key)
+                if (Sibling->ComponentEntry.Class == Class &&
+                    Sibling->ComponentEntry.Type == Type &&
+                    (Sibling->ComponentEntry.Key & Mask) == Key)
                 {
                     /* Match found */
                     return Sibling;
Index: ntoskrnl/ke/dpc.c
===================================================================
--- ntoskrnl/ke/dpc.c	(revision 21808)
+++ ntoskrnl/ke/dpc.c	(working copy)
@@ -439,13 +439,9 @@
     Process = CurrentThread->ApcState.Process;
 
     /* Set DPC Event if requested */
-    if (Prcb->DpcSetEventRequest) {
-        /*
-         * FIXME:
-         *   Prcb->DpcEvent is not initialized.
-         */
-        KEBUGCHECK(0);
-        KeSetEvent(Prcb->DpcEvent, 0, 0);
+    if (Prcb->DpcSetEventRequest)
+    {
+        KeSetEvent(&Prcb->DpcEvent, 0, 0);
     }
 
     /* Check if Quantum expired */
Index: ntoskrnl/ke/i386/usertrap.c
===================================================================
--- ntoskrnl/ke/i386/usertrap.c	(revision 21808)
+++ ntoskrnl/ke/i386/usertrap.c	(working copy)
@@ -61,7 +61,7 @@
 	  current_entry != NULL)
      {
 	current =
-	  CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+	  CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
 	if (address >= (PVOID)current->DllBase &&
 	    address < (PVOID)((char*)current->DllBase + current->SizeOfImage))
Index: ntoskrnl/ke/i386/kernel.c
===================================================================
--- ntoskrnl/ke/i386/kernel.c	(revision 21808)
+++ ntoskrnl/ke/i386/kernel.c	(working copy)
@@ -139,7 +139,7 @@
    if (MaxCpuidLevel >= 0x80000006)
    {
       Ki386Cpuid(0x80000006, &Dummy, &Dummy, &Ecx, &Dummy);
-      Pcr->L2CacheSize = Ecx >> 16;
+      Pcr->SecondLevelCacheSize = Ecx >> 16;
    }
 }
 
@@ -494,9 +494,9 @@
 
       DPRINT("Ke386L1CacheSize: %dkB\n", Ke386L1CacheSize);
    }
-   if (Pcr->L2CacheSize)
+   if (Pcr->SecondLevelCacheSize)
    {
-      DPRINT("Ke386L2CacheSize: %dkB\n", Pcr->L2CacheSize);
+      DPRINT("Ke386L2CacheSize: %dkB\n", Pcr->SecondLevelCacheSize);
    }
 }
 
@@ -532,7 +532,7 @@
    SharedUserData->ProcessorFeatures[PF_3DNOW_INSTRUCTIONS_AVAILABLE] =
        (Ke386CpuidExFlags & X86_EXT_FEATURE_3DNOW) ? TRUE : FALSE;
    SharedUserData->ProcessorFeatures[PF_RDTSC_INSTRUCTION_AVAILABLE] =
-       (Pcr->PrcbData.FeatureBits & X86_FEATURE_TSC) ? TRUE : FALSE;
+       (Pcr->PrcbData.FeatureBits & KF_RDTSC) ? TRUE : FALSE;
    SharedUserData->ProcessorFeatures[PF_PAE_ENABLED] = Ke386Pae;
    SharedUserData->ProcessorFeatures[PF_XMMI64_INSTRUCTIONS_AVAILABLE] =
        (Pcr->PrcbData.FeatureBits & X86_FEATURE_SSE2) ? TRUE : FALSE;
Index: ntoskrnl/ke/i386/irq.c
===================================================================
--- ntoskrnl/ke/i386/irq.c	(revision 21808)
+++ ntoskrnl/ke/i386/irq.c	(working copy)
@@ -19,6 +19,7 @@
 
 #include <ntoskrnl.h>
 #include <../hal/halx86/include/halirq.h>
+#include <../hal/halx86/include/mps.h>
 
 #define NDEBUG
 #include <internal/debug.h>
Index: ntoskrnl/ke/i386/exp.c
===================================================================
--- ntoskrnl/ke/i386/exp.c	(revision 21808)
+++ ntoskrnl/ke/i386/exp.c	(working copy)
@@ -118,7 +118,7 @@
      while (current_entry != &ModuleListHead)
        {
           current =
-            CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList);
+            CONTAINING_RECORD(current_entry, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks);
 
           if (address >= (PVOID)current->DllBase &&
               address < (PVOID)((ULONG_PTR)current->DllBase + current->SizeOfImage))
Index: ntoskrnl/ke/i386/bios.c
===================================================================
--- ntoskrnl/ke/i386/bios.c	(revision 21808)
+++ ntoskrnl/ke/i386/bios.c	(working copy)
@@ -24,11 +24,12 @@
 /* FUNCTIONS *****************************************************************/
 
 NTSTATUS STDCALL
-Ke386CallBios(UCHAR Int, PKV86M_REGISTERS Regs)
+Ke386CallBios(ULONG Int, PCONTEXT regs)
 {
   PUCHAR Ip;
   KV86M_REGISTERS ORegs;
   NTSTATUS Status;
+  PKV86M_REGISTERS Regs = (PKV86M_REGISTERS)regs;
 
   /*
    * Set up a trampoline for executing the BIOS interrupt
Index: ntoskrnl/ke/bug.c
===================================================================
--- ntoskrnl/ke/bug.c	(revision 21808)
+++ ntoskrnl/ke/bug.c	(working copy)
@@ -19,6 +19,14 @@
 #pragma alloc_text(INIT, KiInitializeBugCheck)
 #endif
 
+/* ROS Internal. Please deprecate */
+NTHALAPI
+VOID
+NTAPI
+HalReleaseDisplayOwnership(
+    VOID
+);
+
 /* GLOBALS ******************************************************************/
 
 static LIST_ENTRY BugcheckCallbackListHead = {NULL,NULL};
@@ -315,7 +323,7 @@
         Address = (PVOID)Tf->Eip;
 
         /* Try to get information on the module */
-        LIST_FOR_EACH(CurrentModule, &ModuleListHead, LDR_DATA_TABLE_ENTRY, InLoadOrderModuleList)
+        LIST_FOR_EACH(CurrentModule, &ModuleListHead, LDR_DATA_TABLE_ENTRY, InLoadOrderLinks)
         {
             /* Check if this is the right one */
             if ((Address != NULL && (Address >= (PVOID)CurrentModule->DllBase &&
Index: ntoskrnl/ke/process.c
===================================================================
--- ntoskrnl/ke/process.c	(revision 21808)
+++ ntoskrnl/ke/process.c	(working copy)
@@ -22,8 +22,6 @@
 {
     { MainSSDT, NULL, NUMBER_OF_SYSCALLS, MainSSPT },
     { NULL,     NULL,   0,   NULL   },
-    { NULL,     NULL,   0,   NULL   },
-    { NULL,     NULL,   0,   NULL   }
 };
 
 KSERVICE_TABLE_DESCRIPTOR
@@ -31,8 +29,6 @@
 {
     { MainSSDT, NULL, NUMBER_OF_SYSCALLS, MainSSPT },
     { NULL,     NULL,   0,   NULL   },
-    { NULL,     NULL,   0,   NULL   },
-    { NULL,     NULL,   0,   NULL   }
 };
 
 /* FUNCTIONS *****************************************************************/
@@ -60,8 +56,8 @@
      * To prevent this, make sure the page directory of the process we're
      * attaching to is up-to-date.
      */
-    MmUpdatePageDir((PEPROCESS)Process, (PVOID)Thread->StackLimit, KERNEL_STACK_SIZE);
-    MmUpdatePageDir((PEPROCESS)Process, (PVOID)Thread, sizeof(ETHREAD));
+    MmUpdatePageDir((PROS_EPROCESS)Process, (PVOID)Thread->StackLimit, KERNEL_STACK_SIZE);
+    MmUpdatePageDir((PROS_EPROCESS)Process, (PVOID)Thread, sizeof(ETHREAD));
 }
 
 VOID
Index: ntoskrnl/ke/ipi.c
===================================================================
--- ntoskrnl/ke/ipi.c	(revision 21808)
+++ ntoskrnl/ke/ipi.c	(working copy)
@@ -43,9 +43,9 @@
  * @implemented
  */
 BOOLEAN
-STDCALL
+NTAPI
 KiIpiServiceRoutine(IN PKTRAP_FRAME TrapFrame,
-                    IN PKEXCEPTION_FRAME ExceptionFrame)
+                    IN PVOID ExceptionFrame)
 {
 #ifdef DBG
    LARGE_INTEGER StartTime, CurrentTime, Frequency;
Index: ntoskrnl/ke/kthread.c
===================================================================
--- ntoskrnl/ke/kthread.c	(revision 21808)
+++ ntoskrnl/ke/kthread.c	(working copy)
@@ -154,7 +154,7 @@
                 IdleProcessorMask |= Affinity;
             }
 
-            MmUpdatePageDir(PsGetCurrentProcess(),((PETHREAD)CurrentThread)->ThreadsProcess, sizeof(EPROCESS));
+            MmUpdatePageDir((PROS_EPROCESS)PsGetCurrentProcess(),((PETHREAD)CurrentThread)->ThreadsProcess, sizeof(ROS_EPROCESS));
 
             /* Special note for Filip: This will release the Dispatcher DB Lock ;-) -- Alex */
             DPRINT("You are : %x, swapping to: %x\n", OldThread, CurrentThread);
@@ -864,8 +864,8 @@
      * while handling page faults. At this point it isn't possible to call the
      * page fault handler for the missing pde's.
      */
-    MmUpdatePageDir((PEPROCESS)Process, (PVOID)Thread->StackLimit, KERNEL_STACK_SIZE);
-    MmUpdatePageDir((PEPROCESS)Process, (PVOID)Thread, sizeof(ETHREAD));
+    MmUpdatePageDir((PROS_EPROCESS)Process, (PVOID)Thread->StackLimit, KERNEL_STACK_SIZE);
+    MmUpdatePageDir((PROS_EPROCESS)Process, (PVOID)Thread, sizeof(ETHREAD));
 
     /* Initalize the Thread Context */
     DPRINT("Initializing the Context for the thread: %x\n", Thread);
Index: ntoskrnl/ke/main.c
===================================================================
--- ntoskrnl/ke/main.c	(revision 21808)
+++ ntoskrnl/ke/main.c	(working copy)
@@ -26,7 +26,7 @@
 ULONG NtGlobalFlag = 0;
 CHAR  KeNumberProcessors;
 KAFFINITY KeActiveProcessors = 1;
-LOADER_PARAMETER_BLOCK KeLoaderBlock;
+ROS_LOADER_PARAMETER_BLOCK KeLoaderBlock;
 ULONG KeDcacheFlushCount = 0;
 ULONG KeIcacheFlushCount = 0;
 ULONG KiDmaIoCoherency = 0; /* RISC Architectures only */
@@ -66,7 +66,7 @@
 extern unsigned int _image_base__;
 ULONG_PTR KERNEL_BASE = (ULONG_PTR)&_image_base__;
 
-VOID INIT_FUNCTION _main(ULONG MultiBootMagic, PLOADER_PARAMETER_BLOCK _LoaderBlock);
+VOID INIT_FUNCTION _main(ULONG MultiBootMagic, PROS_LOADER_PARAMETER_BLOCK _LoaderBlock);
 
 #if defined (ALLOC_PRAGMA)
 #pragma alloc_text(INIT, _main)
@@ -146,7 +146,7 @@
 VOID
 INIT_FUNCTION
 _main(ULONG MultiBootMagic,
-      PLOADER_PARAMETER_BLOCK _LoaderBlock)
+      PROS_LOADER_PARAMETER_BLOCK _LoaderBlock)
 {
     ULONG i;
     ULONG size;
@@ -282,7 +282,7 @@
     }
 
     /* Initialize the Debugger */
-    KdInitSystem (0, (PLOADER_PARAMETER_BLOCK)&KeLoaderBlock);
+    KdInitSystem (0, &KeLoaderBlock);
 
     /* Initialize HAL */
     HalInitSystem (0, (PLOADER_PARAMETER_BLOCK)&KeLoaderBlock);
Index: ntoskrnl/ke/clock.c
===================================================================
--- ntoskrnl/ke/clock.c	(revision 21808)
+++ ntoskrnl/ke/clock.c	(working copy)
@@ -42,7 +42,7 @@
 /*
  * Number of timer interrupts since initialisation
  */
-volatile ULONGLONG KeTickCount = 0;
+volatile KSYSTEM_TIME KeTickCount = {0};
 volatile ULONG KiRawTicks = 0;
 
 extern LIST_ENTRY KiTimerListHead;
@@ -165,7 +165,7 @@
  *         TickCount (OUT) = Points to storage for the number of ticks
  */
 {
-    TickCount->QuadPart = KeTickCount;
+    TickCount->QuadPart = *(PULONGLONG)&KeTickCount;
 }
 
 /*
@@ -352,7 +352,7 @@
    /*
     * Increment the number of timers ticks
     */
-   KeTickCount++;
+   (*(PULONGLONG)&KeTickCount)++;
    SharedUserData->TickCountLowDeprecated++;
 
    Time.u.LowPart = SharedUserData->InterruptTime.LowPart;
Index: ntoskrnl/ob/wait.c
===================================================================
--- ntoskrnl/ob/wait.c	(revision 21808)
+++ ntoskrnl/ob/wait.c	(working copy)
@@ -35,7 +35,7 @@
     LARGE_INTEGER SafeTimeOut;
     BOOLEAN LockInUse;
     PHANDLE_TABLE_ENTRY HandleEntry;
-    POBJECT_HEADER ObjectHeader;
+    PROS_OBJECT_HEADER ObjectHeader;
     PHANDLE_TABLE HandleTable;
     ACCESS_MASK GrantedAccess;
     PVOID DefaultObject;
@@ -132,7 +132,7 @@
         }
 
         /* Check for synchronize access */
-        GrantedAccess = HandleEntry->u2.GrantedAccess;
+        GrantedAccess = HandleEntry->GrantedAccess;
         if ((PreviousMode != KernelMode) && (!(GrantedAccess & SYNCHRONIZE)))
         {
             /* Unlock the entry and fail */
Index: ntoskrnl/ob/namespc.c
===================================================================
--- ntoskrnl/ob/namespc.c	(revision 21808)
+++ ntoskrnl/ob/namespc.c	(working copy)
@@ -50,7 +50,7 @@
                   PUNICODE_STRING ObjectName,
                   POBJECT_TYPE ObjectType,
                   ULONG ObjectSize,
-                  POBJECT_HEADER *ObjectHeader);
+                  PROS_OBJECT_HEADER *ObjectHeader);
 
 /* FUNCTIONS **************************************************************/
 
@@ -247,7 +247,7 @@
 VOID
 NTAPI
 ObpAddEntryDirectory(PDIRECTORY_OBJECT Parent,
-		     POBJECT_HEADER Header,
+		     PROS_OBJECT_HEADER Header,
 		     PWSTR Name)
 /*
  * FUNCTION: Add an entry to a namespace directory
@@ -270,7 +270,7 @@
 
 VOID
 NTAPI
-ObpRemoveEntryDirectory(POBJECT_HEADER Header)
+ObpRemoveEntryDirectory(PROS_OBJECT_HEADER Header)
 /*
  * FUNCTION: Remove an entry from a namespace directory
  * ARGUMENTS:
@@ -293,10 +293,10 @@
 NTSTATUS
 STDCALL
 ObpCreateDirectory(OB_OPEN_REASON Reason,
+                   PEPROCESS Process,
                    PVOID ObjectBody,
-                   PEPROCESS Process,
-                   ULONG HandleCount,
-                   ACCESS_MASK GrantedAccess)
+                   ACCESS_MASK GrantedAccess,
+                   ULONG HandleCount)
 {
     PDIRECTORY_OBJECT Directory = ObjectBody;
     
@@ -315,7 +315,7 @@
 		      ULONG Attributes)
 {
    PLIST_ENTRY current = DirectoryObject->head.Flink;
-   POBJECT_HEADER current_obj;
+   PROS_OBJECT_HEADER current_obj;
 
    DPRINT("ObFindEntryDirectory(dir %x, name %S)\n",DirectoryObject, Name);
 
@@ -333,7 +333,7 @@
      }
    while (current!=(&(DirectoryObject->head)))
      {
-	current_obj = CONTAINING_RECORD(current,OBJECT_HEADER,Entry);
+	current_obj = CONTAINING_RECORD(current,ROS_OBJECT_HEADER,Entry);
 	DPRINT("  Scanning: %S for: %S\n",HEADER_TO_OBJECT_NAME(current_obj)->Name.Buffer, Name);
 	if (Attributes & OBJ_CASE_INSENSITIVE)
 	  {
@@ -458,7 +458,7 @@
     ObjectTypeInitializer.ValidAccessMask = DIRECTORY_ALL_ACCESS;
     ObjectTypeInitializer.UseDefaultObject = FALSE;
     ObjectTypeInitializer.OpenProcedure = ObpCreateDirectory;
-    ObjectTypeInitializer.ParseProcedure = ObpParseDirectory;
+    ObjectTypeInitializer.ParseProcedure = (OB_PARSE_METHOD)ObpParseDirectory;
     ObjectTypeInitializer.MaintainTypeList = FALSE;
     ObjectTypeInitializer.GenericMapping = ObpDirectoryMapping;
     ObjectTypeInitializer.DefaultNonPagedPoolCharge = sizeof(DIRECTORY_OBJECT);
@@ -526,8 +526,8 @@
     
     /* Insert the two objects we already created but couldn't add */
     /* NOTE: Uses TypeList & Creator Info in OB 2.0 */
-    ObpAddEntryDirectory(ObpTypeDirectoryObject, BODY_TO_HEADER(ObTypeObjectType), NULL);
-    ObpAddEntryDirectory(ObpTypeDirectoryObject, BODY_TO_HEADER(ObDirectoryType), NULL);
+    ObpAddEntryDirectory(ObpTypeDirectoryObject, (PROS_OBJECT_HEADER)BODY_TO_HEADER(ObTypeObjectType), NULL);
+    ObpAddEntryDirectory(ObpTypeDirectoryObject, (PROS_OBJECT_HEADER)BODY_TO_HEADER(ObDirectoryType), NULL);
 
     /* Create 'symbolic link' object type */
     ObInitSymbolicLinkImplementation();
@@ -543,7 +543,7 @@
                     PUNICODE_STRING TypeName,
                     POBJECT_TYPE *ObjectType)
 {
-    POBJECT_HEADER Header;
+    PROS_OBJECT_HEADER Header;
     POBJECT_TYPE LocalObjectType;
     ULONG HeaderSize;
     NTSTATUS Status;
@@ -555,7 +555,7 @@
                                TypeName,
                                ObTypeObjectType, 
                                OBJECT_ALLOC_SIZE(sizeof(OBJECT_TYPE)),
-                               &Header);
+                               (PROS_OBJECT_HEADER*)&Header);
     if (!NT_SUCCESS(Status))
     {
         DPRINT1("ObpAllocateObject failed!\n");
@@ -601,7 +601,7 @@
     }
 
     /* Calculate how much space our header'll take up */
-    HeaderSize = sizeof(OBJECT_HEADER) + sizeof(OBJECT_HEADER_NAME_INFO) +
+    HeaderSize = sizeof(ROS_OBJECT_HEADER) + sizeof(OBJECT_HEADER_NAME_INFO) +
                  (ObjectTypeInitializer->MaintainHandleCount ? 
                  sizeof(OBJECT_HEADER_HANDLE_INFO) : 0);
 
